import {createApp} from 'vue'
import App from './App'
import { createRouter, createWebHistory } from "vue-router"

import Customers from './components/Customers'
import Feed from './components/Feed'
import Login from "@/components/Login.vue";
import Signup from "@/components/Signup.vue";
import Admin from "@/components/Admin.vue";

const routes = [
    {
        path: '/customers/:id?',
        name: "Customers",
        component: Customers
    },
    {
        path: '/feed',
        name: "Feed",
        component: Feed
    },
    {
        path: '/login',
        name: "Login",
        component: Login
    },
    {
        path: '/signup',
        name: "Signup",
        component: Signup
    },
    {
        path: '/admin',
        name: "Admin",
        component: Admin
    }
]

const router = createRouter({
    routes, 
    history: createWebHistory()
})


createApp(App).use(router).mount('#app')