package np.something.DTO;

import np.something.model.Comment;

import com.fasterxml.jackson.annotation.JsonProperty;
import java.time.format.DateTimeFormatter;

public class CommentDto {
    public long id;
    public String content;
    public long customerId;
    public String customerName;
    public long postId;
    public String postTitle;
    public String postAuthor;
    public long postAuthorId;
    public String createDate;

    public CommentDto() {

    }

    public CommentDto(Comment comment) {
        this.id = comment.getId();
        this.content = comment.getContent();
        this.customerId = comment.getCustomer().getId();
        this.customerName = comment.getCustomer().getUsername();
        this.postId = comment.getPost().getId();
        this.postTitle = comment.getPost().getTitle();
        this.postAuthor = comment.getPost().getCustomer().getUsername();
        this.postAuthorId = comment.getPost().getCustomer().getId();
        this.createDate = comment.getCreateDate().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public long getId() {
        return id;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public long getCustomerId() {
        return customerId;
    }

    public void setCustomerId(long customerId) {
        this.customerId = customerId;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public String getCustomerName() {
        return customerName;
    }

    public long getPostId() {
        return postId;
    }

    public void setPostId(long postId) {
        this.postId = postId;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public String getPostTitle() {return postTitle;}

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public String getPostAuthor() {
        return postAuthor;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public long getPostAuthorId() {
        return postAuthorId;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public String getCreateDate() {
        return createDate;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        CommentDto that = (CommentDto) o;

        return id == that.id;
    }

    @Override
    public int hashCode() {
        return (int) (id ^ (id >>> 32));
    }
}
