package np.something.DTO;

import com.fasterxml.jackson.annotation.JsonProperty;
import np.something.model.Customer;

import java.io.Serializable;
import java.util.List;

public class CustomerDto {
    public long id;
    public String username;
    public String password;
    public List<CommentDto> comments;
    public List<PostDto> posts;

    public CustomerDto() {

    }

    public CustomerDto(Customer customer) {
        this.id = customer.getId();
        this.username = customer.getUsername();
        this.password = customer.getPassword();
        this.comments = customer.getComments().stream().map(CommentDto::new).toList();
        this.posts = customer.getPosts().stream().map(PostDto::new).toList();
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public long getId() {
        return id;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public List<CommentDto> getComments() {
        return comments;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public List<PostDto> getPosts() {
        return posts;
    }
}
