package np.something.DTO;

import com.fasterxml.jackson.annotation.JsonProperty;
import np.something.model.Post;

import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.List;

public class PostDto {
    public long id;
    public String title;
    public String content;
    public String customerName;
    public long customerId;
    public ArrayList<CommentDto> comments;

    public String createDate;

    public PostDto() {

    }

    public PostDto(Post post) {
        this.id = post.getId();
        this.title = post.getTitle();
        this.content = post.getContent();
        this.customerName = post.getCustomer().getUsername();
        this.customerId = post.getCustomer().getId();
        this.comments = new ArrayList<>(post.getComments().stream().map(CommentDto::new).toList());
        this.createDate = post.getCreateDate().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public long getId() {
        return id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public String getCustomerName() {
        return customerName;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public List<CommentDto> getComments() {
        return comments;
    }

    public long getCustomerId() {
        return customerId;
    }

    public void setCustomerId(long customerId) {
        this.customerId = customerId;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public String getCreateDate() {
        return createDate;
    }
}
